searchNodes=[{"doc":"RTC Engine implementation. RTC Engine is an abstraction layer responsible for linking together different types of Endpoints . From the implementation point of view, RTC Engine is a Membrane.Pipeline . Messages The RTC Engine works by sending messages which notify user logic about important events. To receive RTC Engine messages you have to register your process so that RTC Engine will know where to send them. All messages RTC Engine can emit are described in Membrane.RTC.Engine.Message docs. Registering for messages Registration can be done using register/2 e.g. Engine . register ( rtc_engine , self ( ) ) This will register your process to receive RTC Engine messages. You can register multiple processes to receive messages from an RTC Engine instance. In such a case each message will be sent to each registered process. Peers Deprecation notice Peers are deprecated as of version 0.10.0 and will be removed in the future While Peers are still present in the RTC Engine, it's not recommended to use this feature in new applications. Existing applications should take steps to move away from using built-in concept of peers. Each peer represents some user that can possess some metadata. In RTC Engine, each peer is represented by an endpoint and from the purposes of the Engine, it is an enpdoint that we happen to store additional information about, metadata in particular. The peer doesn't exist without their endpoint. Adding a peer The only way to add a peer to the RTC Engine is to assign a peer_id to the endpoint representing it. This is done when adding an endpoint to the Engine by passing a peer_id option. Example :ok = Engine . add_endpoint ( webrtc_endpoint , peer_id : &quot;Peer1&quot; ) Each peer then needs to declare itself as ready before being fully connected to RTC Engine. Readiness state Each peer endpoint is presumed to be initially inactive and has to declare itself ready to fully join the Engine. Before it does, it: will not receive notifications about other peers and their metadata will not receive information about tracks will not be able to publish any tracks will not be able to update their metadata When declaring itself as ready, the peer also has an opportunity to set their metadata. To mark the peer as active, their endpoint has to send the ready_action_t/0 . Example @impl true def handle_other ( { :media_event , %{ type : &quot;join&quot; , metadata : metadata } } , _context , state ) do { { :ok , notify : { :ready , metadata } } , state } end @impl true def handle_other ( :ready , _context , state ) do Membrane.Logger . debug ( &quot;Succesfully activated the peer&quot; ) { :ok , state } end Endpoints Endpoints are Membrane.Bin s able to publish their own tracks and subscribe to tracks from other Endpoints. One can think about Endpoint as an entity responsible for handling some specific task. An Endpoint can be added and removed using add_endpoint/3 and remove_endpoint/2 respectively. There are two types of Endpoints: Standalone Endpoints - they are in most cases spawned only once per RTC Engine instance and they are not associated with any peer. Peer Endpoints - they are associated with some peer. Associating Endpoint with Peer will cause RTC Engine to send some Media Events to the Enpoint's Client Library e.g. one which indicates which tracks belong to which peer. Currently RTC Engine ships with the implementation of two Endpoints: Membrane.RTC.Engine.Endpoint.WebRTC which is responsible for establishing a connection with some WebRTC peer (mainly browser) and exchanging media with it. WebRTC Endpoint is a Peer Endpoint. Membrane.RTC.Engine.Endpoint.HLS which is responsible for receiving media tracks from all other Endpoints and saving them to files by creating HLS playlists. HLS Endpoint is a Standalone Endpoint. User can also implement custom Endpoints, see Custom Endpoints guide.","ref":"Membrane.RTC.Engine.html","title":"Membrane.RTC.Engine","type":"module"},{"doc":"Adds endpoint to the RTC Engine Returns :error when there are both peer_id and endpoint_id specified in opts . For more information refer to endpoint_options_t/0 .","ref":"Membrane.RTC.Engine.html#add_endpoint/3","title":"Membrane.RTC.Engine.add_endpoint/3","type":"function"},{"doc":"","ref":"Membrane.RTC.Engine.html#get_registry_name/0","title":"Membrane.RTC.Engine.get_registry_name/0","type":"function"},{"doc":"Sends message to RTC Engine endpoint. If endpoint doesn't exist message is ignored","ref":"Membrane.RTC.Engine.html#message_endpoint/3","title":"Membrane.RTC.Engine.message_endpoint/3","type":"function"},{"doc":"Changes playback state of pipeline to :playing .","ref":"Membrane.RTC.Engine.html#play/1","title":"Membrane.RTC.Engine.play/1","type":"function"},{"doc":"Changes playback state to :prepared .","ref":"Membrane.RTC.Engine.html#prepare/1","title":"Membrane.RTC.Engine.prepare/1","type":"function"},{"doc":"Registers process with pid who for receiving messages from RTC Engine","ref":"Membrane.RTC.Engine.html#register/2","title":"Membrane.RTC.Engine.register/2","type":"function"},{"doc":"Removes endpoint from the RTC Engine","ref":"Membrane.RTC.Engine.html#remove_endpoint/2","title":"Membrane.RTC.Engine.remove_endpoint/2","type":"function"},{"doc":"","ref":"Membrane.RTC.Engine.html#start/2","title":"Membrane.RTC.Engine.start/2","type":"function"},{"doc":"","ref":"Membrane.RTC.Engine.html#start_link/2","title":"Membrane.RTC.Engine.start_link/2","type":"function"},{"doc":"Changes playback state to :stopped .","ref":"Membrane.RTC.Engine.html#stop/1","title":"Membrane.RTC.Engine.stop/1","type":"function"},{"doc":"Changes pipeline's playback state to :stopped and terminates its process.","ref":"Membrane.RTC.Engine.html#stop_and_terminate/2","title":"Membrane.RTC.Engine.stop_and_terminate/2","type":"function"},{"doc":"Subscribes an endpoint for a track. The endpoint will be notified about track readiness in Membrane.Bin.handle_pad_added/3 callback. endpoint_id is the id of the endpoint, which wants to subscribe to the track.","ref":"Membrane.RTC.Engine.html#subscribe/4","title":"Membrane.RTC.Engine.subscribe/4","type":"function"},{"doc":"Changes pipeline's playback state to :stopped and terminates its process.","ref":"Membrane.RTC.Engine.html#terminate/2","title":"Membrane.RTC.Engine.terminate/2","type":"function"},{"doc":"Unregisters process with pid who from receiving messages from RTC Engine","ref":"Membrane.RTC.Engine.html#unregister/2","title":"Membrane.RTC.Engine.unregister/2","type":"function"},{"doc":"Endpoint configuration options. peer_id - associate endpoint with existing peer endpoint_id - assign endpoint id. If not provided it will be generated by RTC Engine. This option cannot be used together with peer_id . Endpoints associated with peers have the id peer_id . node - node on which endpoint should be spawned. If not provided, current node is used.","ref":"Membrane.RTC.Engine.html#t:endpoint_options_t/0","title":"Membrane.RTC.Engine.endpoint_options_t/0","type":"type"},{"doc":"Membrane action that will cause RTC Engine to forward supplied message to the business logic.","ref":"Membrane.RTC.Engine.html#t:forward_to_parent_action_t/0","title":"Membrane.RTC.Engine.forward_to_parent_action_t/0","type":"type"},{"doc":"RTC Engine configuration options. id is used by logger. If not provided it will be generated. trace_ctx is used by OpenTelemetry. All traces from this engine will be attached to this context. Example function from which you can get Otel Context is get_current/0 from OpenTelemetry.Ctx . display_manager? - set to true if you want to limit number of tracks sent from Membrane.RTC.Engine.Endpoint.WebRTC to a browser.","ref":"Membrane.RTC.Engine.html#t:options_t/0","title":"Membrane.RTC.Engine.options_t/0","type":"type"},{"doc":"Membrane action that will cause RTC Engine to publish some message to all other endpoints.","ref":"Membrane.RTC.Engine.html#t:publish_action_t/0","title":"Membrane.RTC.Engine.publish_action_t/0","type":"type"},{"doc":"Types of messages that can be published to other Endpoints.","ref":"Membrane.RTC.Engine.html#t:publish_message_t/0","title":"Membrane.RTC.Engine.publish_message_t/0","type":"type"},{"doc":"Type of messages that need to be handled by each endpoint.","ref":"Membrane.RTC.Engine.html#t:published_message_t/0","title":"Membrane.RTC.Engine.published_message_t/0","type":"type"},{"doc":"A message that the Engine sends to the endpoint when it ackowledges its ready_action_t/0","ref":"Membrane.RTC.Engine.html#t:ready_ack_msg_t/0","title":"Membrane.RTC.Engine.ready_ack_msg_t/0","type":"type"},{"doc":"Membrane action that will mark the peer endpoint as ready and set its metadata. The Engine will respond with ready_ack_msg_t/0 to acknowledge your transition to ready state. This action can only be used once, any further calls by an endpoint will be ignored. It will also be ignored for non-peer endpoints.","ref":"Membrane.RTC.Engine.html#t:ready_action_t/0","title":"Membrane.RTC.Engine.ready_action_t/0","type":"type"},{"doc":"Subscription options.","ref":"Membrane.RTC.Engine.html#t:subscription_opts_t/0","title":"Membrane.RTC.Engine.subscription_opts_t/0","type":"type"},{"doc":"Membrane action that will inform RTC Engine about track readiness.","ref":"Membrane.RTC.Engine.html#t:track_ready_action_t/0","title":"Membrane.RTC.Engine.track_ready_action_t/0","type":"type"},{"doc":"Module describing messages RTC Engine can emit. Each Message contains RTC Engine PID under rtc_engine field. Thanks to it you can distinguish between the same messages but from different RTC Engine instances.","ref":"Membrane.RTC.Engine.Message.html","title":"Membrane.RTC.Engine.Message","type":"module"},{"doc":"","ref":"Membrane.RTC.Engine.Message.html#t:t/0","title":"Membrane.RTC.Engine.Message.t/0","type":"type"},{"doc":"Defines list of metrics, that Reporter instance can aggregate by listening on events emitted in RTC Engine. Suggested Reporter implementation is Membrane.TelemetryMetrics.Reporter from membrane_telemetry_metrics . Membrane.TelemetryMetrics.Reporter started with metrics returned by metrics/1 function will be able to generate reports, that matches type Membrane.RTC.Engine.Metrics.rtc_engine_report() You can see usage example in ( membrane_videoroom )[github.com/membraneframework/membrane_videoroom].","ref":"Membrane.RTC.Engine.Metrics.html","title":"Membrane.RTC.Engine.Metrics","type":"module"},{"doc":"","ref":"Membrane.RTC.Engine.Metrics.html#metrics/0","title":"Membrane.RTC.Engine.Metrics.metrics/0","type":"function"},{"doc":"","ref":"Membrane.RTC.Engine.Metrics.html#t:rtc_engine_report/0","title":"Membrane.RTC.Engine.Metrics.rtc_engine_report/0","type":"type"},{"doc":"Struct describing a track notification sent to the instance of Membrane.RTC.Engine by Endpoints. TrackNotification command indicates that the engine should forward a notification about the specified track to all endpoints subscribed to that track. Receivers can choose to ignore the notification . The same struct will appear in handle_other/3 callback on the receiver side. Publishing the notification Endpoint can publish a TrackNotification about any of the tracks it publishes, making the following pattern. notification = % Membrane.RTC.Engine.Notifications.TrackNotification { track_id : &quot;trackID_1&quot; , notification : :hello_world } { { :ok , notify : { :publish , notification } } , state }","ref":"Membrane.RTC.Engine.Notifications.TrackNotification.html","title":"Membrane.RTC.Engine.Notifications.TrackNotification","type":"module"},{"doc":"Type describing track notification struct track_id - id of the track that this notification is about. This the id of the track that was assigned to the track when publishing it to the engine. notification - payload of the notification. Can be anything","ref":"Membrane.RTC.Engine.Notifications.TrackNotification.html#t:t/0","title":"Membrane.RTC.Engine.Notifications.TrackNotification.t/0","type":"type"},{"doc":"Module describing Peer.","ref":"Membrane.RTC.Engine.Peer.html","title":"Membrane.RTC.Engine.Peer","type":"module"},{"doc":"","ref":"Membrane.RTC.Engine.Peer.html#new/2","title":"Membrane.RTC.Engine.Peer.new/2","type":"function"},{"doc":"","ref":"Membrane.RTC.Engine.Peer.html#t:id/0","title":"Membrane.RTC.Engine.Peer.id/0","type":"type"},{"doc":"","ref":"Membrane.RTC.Engine.Peer.html#t:t/0","title":"Membrane.RTC.Engine.Peer.t/0","type":"type"},{"doc":"Module representing media track. Media track is a single audio or video. Tracks that are related to each other (e.g. audio from microphone that corresponds to video from a web cam) can be grouped into the same stream by assigning each of them the same stream id.","ref":"Membrane.RTC.Engine.Track.html","title":"Membrane.RTC.Engine.Track","type":"module"},{"doc":"Returns depayloader for given track. Depayloader can be used to unpack RTP stream i.e. get data out of RTP packets. Returns Membrane child specification or nil if depayloader couldn't be determined. Examples @impl true def handle_pad_added ( Pad . ref ( :input , track_id ) = pad , _ctx , state ) do children = %{ { :track_receiver , track_id } =&gt; % TrackReceiver { track : Map . fetch! ( state . tracks , track_id ) , initial_target_variant : :high } , { :depayloader , track . id } =&gt; get_depayloader ( track ) , { :serializer , track_id } =&gt; Membrane.Stream.Serializer , { :sink , track_id } =&gt; % Membrane.File.Sink { location : Path . join ( state . output_dir_path , track_id ) } } links = [ link_bin_input ( pad ) |&gt; to ( { :track_receiver , track_id } ) |&gt; to ( { :depayloader , track . id } ) |&gt; to ( { :serializer , track_id } ) |&gt; to ( { :sink , track_id } ) ] { { :ok , spec : % ParentSpec { children : children , links : links } } , state } end","ref":"Membrane.RTC.Engine.Track.html#get_depayloader/1","title":"Membrane.RTC.Engine.Track.get_depayloader/1","type":"function"},{"doc":"Checks whether track is a simulcast one or not.","ref":"Membrane.RTC.Engine.Track.html#is_simulcast?/1","title":"Membrane.RTC.Engine.Track.is_simulcast?/1","type":"function"},{"doc":"Creates a new track. Tracks belonging to the same stream should have the same stream_id , that can be generated with stream_id/0 .","ref":"Membrane.RTC.Engine.Track.html#new/7","title":"Membrane.RTC.Engine.Track.new/7","type":"function"},{"doc":"Generates stream id, that can be used to mark tracks belonging to the same stream.","ref":"Membrane.RTC.Engine.Track.html#stream_id/0","title":"Membrane.RTC.Engine.Track.stream_id/0","type":"function"},{"doc":"Returns list of supported track variants.","ref":"Membrane.RTC.Engine.Track.html#supported_variants/0","title":"Membrane.RTC.Engine.Track.supported_variants/0","type":"function"},{"doc":"","ref":"Membrane.RTC.Engine.Track.html#t:encoding/0","title":"Membrane.RTC.Engine.Track.encoding/0","type":"type"},{"doc":"","ref":"Membrane.RTC.Engine.Track.html#t:id/0","title":"Membrane.RTC.Engine.Track.id/0","type":"type"},{"doc":"Options that can be passed to new/7 . If not provided: id - will be generated active? - true variants - [:high] metadata - nil ctx - %{} For more information refer to t/0 .","ref":"Membrane.RTC.Engine.Track.html#t:opts_t/0","title":"Membrane.RTC.Engine.Track.opts_t/0","type":"type"},{"doc":"This module contains: type - audio or video, stream_id - media stream this track belongs to. Relationship between tracks (e.g. audio and video) can be indicated by assigning each of them the same stream_id . One stream_id can be assign to any number of tracks. id - track id origin - id of Endpoint this track belongs to encoding - track encoding variants - list of possible track variants. Refer to variant/0 . clock_rate - track clock rate fmtp - struct describing format specific parameters e.g. for H264 it contains profile_level_id active? - indicates whether track is still available or not (because peer left a room) metadata - any data passed by user to be linked with this track ctx - any data Endpoints need to associate with Membrane.RTC.Engine.Track.t() for internal usage","ref":"Membrane.RTC.Engine.Track.html#t:t/0","title":"Membrane.RTC.Engine.Track.t/0","type":"type"},{"doc":"Possible track variants. The usage should be as follows: :high - main track variant :medium - lower (in terms of quality) track variant :low - the lowest track variant Audio tracks can have only one variant - :high .","ref":"Membrane.RTC.Engine.Track.html#t:variant/0","title":"Membrane.RTC.Engine.Track.variant/0","type":"type"},{"doc":"Struct describing bitrate estimation.","ref":"Membrane.RTC.Engine.Track.BitrateEstimation.html","title":"Membrane.RTC.Engine.Track.BitrateEstimation","type":"module"},{"doc":"Type describing bitrate estimation: estimation - estimated bitrate in kbps error - expected error of the estimation","ref":"Membrane.RTC.Engine.Track.BitrateEstimation.html#t:t/0","title":"Membrane.RTC.Engine.Track.BitrateEstimation.t/0","type":"type"},{"doc":"An Endpoint responsible for converting incoming tracks to HLS playlist. This module requires the following plugins to be present in your mix.exs for H264 &amp; OPUS input: [ :membrane_h264_ffmpeg_plugin , :membrane_http_adaptive_stream_plugin , ] It can perform transcoding (see Membrane.RTC.Engine.Endpoint.HLS.TranscodingConfig ), in such case these plugins are also needed: [ :membrane_ffmpeg_swscale_plugin , :membrane_framerate_converter_plugin ] Plus, optionally it supports OPUS audio input - for that, additional dependencies are needed: [ :membrane_opus_plugin , :membrane_aac_plugin , :membrane_aac_fdk_plugin ] Bin options Passed via struct Membrane.RTC.Engine.Endpoint.HLS.t/0 rtc_engine pid ( ) Required Pid of parent Engine output_directory Path . t ( ) Default value: &quot;hls_output&quot; Path to directory under which HLS output will be saved owner pid ( ) Required Pid of parent all notifications will be send to. These notifications are: {:playlist_playable, content_type, stream_id, origin} {:cleanup, clean_function, stream_id} hls_mode :separate_av | :muxed_av Default value: :separate_av Defines output mode for Membrane.HTTPAdaptiveStream.SinkBin . :separate_av - audio and video tracks will be separated :muxed_av - audio will be attached to every video track target_window_duration Membrane.Time . t ( ) | :infinity Default value: 20 |&gt; Membrane.Time.seconds() Max duration of stream that will be stored. Segments that are older than window duration will be removed. target_segment_duration Membrane.Time . t ( ) Default value: 5 |&gt; Membrane.Time.seconds() Expected length of each segment. Setting it is not necessary, but may help players achieve better UX. framerate { integer ( ) , integer ( ) } | nil Default value: nil Framerate of input tracks transcoding_config TranscodingConfig . t ( ) Default value: %Membrane.RTC.Engine.Endpoint.HLS.TranscodingConfig{enabled?: false, output_framerate: {24, 1}, output_width: 1280, output_height: 720} Transcoding configuration Pads :input Availability :on_request Caps :any Demand unit :buffers Direction :input Mode :pull Name :input","ref":"Membrane.RTC.Engine.Endpoint.HLS.html","title":"Membrane.RTC.Engine.Endpoint.HLS","type":"module"},{"doc":"Returns pads descriptions for Membrane.RTC.Engine.Endpoint.HLS","ref":"Membrane.RTC.Engine.Endpoint.HLS.html#membrane_pads/0","title":"Membrane.RTC.Engine.Endpoint.HLS.membrane_pads/0","type":"function"},{"doc":"Returns description of options available for this module","ref":"Membrane.RTC.Engine.Endpoint.HLS.html#options/0","title":"Membrane.RTC.Engine.Endpoint.HLS.options/0","type":"function"},{"doc":"Struct containing options for Membrane.RTC.Engine.Endpoint.HLS","ref":"Membrane.RTC.Engine.Endpoint.HLS.html#t:t/0","title":"Membrane.RTC.Engine.Endpoint.HLS.t/0","type":"type"},{"doc":"Module representing transcoding configuration for the HLS endpoint. When enabled, transcoding will unify video framerate and resolution. Transcoding is useful when consuming tracks with variable parameters i.e. changing resolution and/or framerate (e.g. tracks coming from WebRTC endpoint). Such tracks are often problematic for HLS players as it's hard to ensure video smoothness at parameters change.","ref":"Membrane.RTC.Engine.Endpoint.HLS.TranscodingConfig.html","title":"Membrane.RTC.Engine.Endpoint.HLS.TranscodingConfig","type":"module"},{"doc":"enabled? - whether to perform transcoding or not, false by default. output_framerate - framerate of the output video, {24, 1} by default. output_width - resolution width of the output video, 1280 by default. output_height - resolution height of the output video, 720 by default.","ref":"Membrane.RTC.Engine.Endpoint.HLS.TranscodingConfig.html#t:t/0","title":"Membrane.RTC.Engine.Endpoint.HLS.TranscodingConfig.t/0","type":"type"},{"doc":"An Endpoint responsible for communicatiing with WebRTC peer. It is responsible for sending and receiving media tracks from other WebRTC peer (e.g. web browser). Signalling In order to operate correctly, this endpoint requires that the business logic implements the signalling channel to the peer it represents. Implementation details are not important to endpoint. Signalling in WebRTC is used to eg. facilitate SDP negotiation or send notifications regarding the session. This endpoint uses an abstraction of Media Events to achieve this. A Media Event is a black box message sent between the Client Library and this endpoint. The business logic will receive an encoded media event in binary form from both the endpoint and the client library. It's only responsibility is to feed the binary to either the endpoint or the client library. Message Protocol Definition The business logic must receive media_event_message_t/0 message from the endpoint and forward it to the client over the implemented signalling channel. Mind you, this message will be wrapped with Membrane.RTC.Engine.Message.EndpointMessage.t/0 Example @impl GenServer def handle_info ( % Membrane.RTC.Engine.Message.EndpointMessage { endpoint_id : endpoint , message : { :media_event , _event } = message } , state ) do send state . channels [ endpoint ] , message { :noreply , state } end Simmilarily, it must forward all media events it receives over the signalling channel to the endpoint by sending a media_event_message_t/0 to it. Example. @impl GenServer def handle_info ( { :media_event , origin , event } , state ) do endpoint_id = state . peer_channel_to_endpoint_id [ origin ] Engine . message_endpoint ( endpoint_id , { :media_event , event } ) { :noreply , state } end Client libraries The following client libraries for handling signalling messages are available: Typescript library intended for use in web browsers Android native library IOS native library Monitoring track activity WebRTC Endpoint only monitors simulcast tracks activity, meaning that it never emits Membrane.RTC.Engine.Event.TrackVariantPaused event for non-simulcast tracks. The main reason is that it's impossible to tell if the screensharing track is inactive or not sending any packets because it contains static content. Bin options Passed via struct Membrane.RTC.Engine.Endpoint.WebRTC.t/0 rtc_engine pid ( ) Required Pid of parent Engine direction EndpointBin . direction ( ) Default value: :sendrecv Direction of WebRTC Endpoint. Determines whether EndpointBin can send, receive or both send and receive media. For more information refer to t:EndpointBin.direction/0. ice_name String . t ( ) Required Ice name is used in creating credentials for ice connnection handshake_opts Keyword . t ( ) Default value: [] Keyword list with options for handshake module. For more information please refer to Membrane.ICE.Bin filter_codecs ( { RTPMapping . t ( ) , FMTP . t ( ) | nil } -&gt; boolean ( ) ) Default value: &amp;Membrane.WebRTC.SDP.filter_mappings/1 Defines function which will filter SDP m-line by codecs log_metadata :list Default value: [] Logger metadata used for endpoint bin and all its descendants webrtc_extensions [ module ( ) ] Default value: [] List of WebRTC extensions to use. Each module has to implement Membrane.WebRTC.Extension.t() . See membrane_webrtc_plugin documentation for a list of possible extensions. extensions %{ ( encoding_name :: atom ( ) | :any ) =&gt; [ Membrane.RTP.SessionBin . extension_t ( ) ] } Default value: %{} A map pointing from encoding names to lists of extensions that should be used for given encodings. Encoding &quot; :any &quot; indicates that extensions should be applied regardless of encoding. A sample usage would be to add silence discarder to OPUS tracks when VAD extension is enabled. It can greatly reduce CPU usage in rooms when there are a lot of people but only a few of them are actively speaking. integrated_turn_domain binary ( ) | nil Default value: nil Domain address of integrated TURN Servers. Required for TLS TURN integrated_turn_options Membrane.ICE.Endpoint . integrated_turn_options_t ( ) Default value: [] owner pid ( ) Required Pid of parent all notifications will be send to. To see possible notifications please refer to module docs. trace_context :list Default value: [] Trace context for otel propagation parent_span :opentelemetry . span_ctx ( ) | nil Default value: nil Parent span of webrtc_endpoint.life_span video_tracks_limit integer ( ) | nil Default value: nil Maximal number of video tracks that will be sent to the the browser at the same time. This variable indicates how many video tracks should be sent to the browser at the same time. If nil all video tracks this Membrane.RTC.Engine.Endpoint.WebRTC receives will be sent. rtcp_receiver_report_interval Membrane.Time . t ( ) | nil Default value: nil Receiver reports's generation interval, set to nil to avoid reports generation rtcp_sender_report_interval Membrane.Time . t ( ) | nil Default value: nil Sender reports's generation interval, set to nil to avoid reports generation simulcast_config SimulcastConfig . t ( ) Default value: %Membrane.RTC.Engine.Endpoint.WebRTC.SimulcastConfig{enabled: false, initial_target_variant: &amp;Membrane.RTC.Engine.Endpoint.WebRTC.SimulcastConfig.initial_target_variant/1} Simulcast configuration peer_metadata any ( ) Default value: nil Peer metadata telemetry_label Membrane.TelemetryMetrics . label ( ) Default value: [] Label passed to Membrane.TelemetryMetrics functions toilet_capacity pos_integer ( ) Default value: 200 TrackReceiver toilet capacity Pads :input Availability :on_request Caps :any Demand unit :buffers Direction :input Mode :pull Name :input :output Availability :on_request Caps :any Demand unit :buffers Direction :output Mode :pull Name :output","ref":"Membrane.RTC.Engine.Endpoint.WebRTC.html","title":"Membrane.RTC.Engine.Endpoint.WebRTC","type":"module"},{"doc":"Returns pads descriptions for Membrane.RTC.Engine.Endpoint.WebRTC","ref":"Membrane.RTC.Engine.Endpoint.WebRTC.html#membrane_pads/0","title":"Membrane.RTC.Engine.Endpoint.WebRTC.membrane_pads/0","type":"function"},{"doc":"Returns description of options available for this module","ref":"Membrane.RTC.Engine.Endpoint.WebRTC.html#options/0","title":"Membrane.RTC.Engine.Endpoint.WebRTC.options/0","type":"function"},{"doc":"","ref":"Membrane.RTC.Engine.Endpoint.WebRTC.html#t:encoding_t/0","title":"Membrane.RTC.Engine.Endpoint.WebRTC.encoding_t/0","type":"type"},{"doc":"Type describing message format used to send media events both to the business logic and by the business logic to this endpoint.","ref":"Membrane.RTC.Engine.Endpoint.WebRTC.html#t:media_event_message_t/0","title":"Membrane.RTC.Engine.Endpoint.WebRTC.media_event_message_t/0","type":"type"},{"doc":"Struct containing options for Membrane.RTC.Engine.Endpoint.WebRTC","ref":"Membrane.RTC.Engine.Endpoint.WebRTC.html#t:t/0","title":"Membrane.RTC.Engine.Endpoint.WebRTC.t/0","type":"type"},{"doc":"Behavior defining a set of functions for managing connection allocations for TrackReceivers. It is responsible for allocating connection bandwidth for track receivers and probing the connection. Message protocol In addition to implementing the behavior, Each implementation of ConnectionAllocator should be aware of the following message protocol. Membrane.RTC.Engine.Endpoint.WebRTC.TrackReceiver already implements proper handling of this message protocol. Granting an allocation Membrane.RTC.Engine.Endpoint.WebRTC.ConnectionAllocator.AllocationGrantedNotification.t/0 message is sent to TrackReceiver when ConnectionAllocator wants to grant an allocation. TrackReceiver is obligated to comply. This message can also be used to force-lower the allocation of a particular TrackReceiver, skipping the negotiation flow. Negotiating lower allocation Whenever it is deemed necessary, ConnectionAllocator can send decrease_allocation_request/0 to selected TrackReceiver, to request that it lowers its allocation by unspecified amount. Usually, this will mean that TrackReceiver selects a lower variant (if possible). In response, TrackReceiver sends decrease_allocation_request_response/0 to ConnectionAllocator. If the request was accepted, TrackReceiver is obligated to request lower allocation immediately after sending a reply. Example of decrease allocation request message flow CA - Connection Allocator TR - Track Receiver CA -&gt; TR : :decrease_your_allocation TR -&gt; CA : { :decrease_allocation_request , :accept } TR calls ` request_allocation / 2 ` with lowered allocation CA -&gt; AllocationGrantedNotification","ref":"Membrane.RTC.Engine.Endpoint.WebRTC.ConnectionAllocator.html","title":"Membrane.RTC.Engine.Endpoint.WebRTC.ConnectionAllocator","type":"behaviour"},{"doc":"Function invoked by the TrackReceiver whenever a buffer is sent","ref":"Membrane.RTC.Engine.Endpoint.WebRTC.ConnectionAllocator.html#c:buffer_sent/2","title":"Membrane.RTC.Engine.Endpoint.WebRTC.ConnectionAllocator.buffer_sent/2","type":"callback"},{"doc":"A function that should be used by the WebRTC Endpoint to create an instance of ConnectionAllocator","ref":"Membrane.RTC.Engine.Endpoint.WebRTC.ConnectionAllocator.html#c:create/0","title":"Membrane.RTC.Engine.Endpoint.WebRTC.ConnectionAllocator.create/0","type":"callback"},{"doc":"A function that should be used by the endpoint to destroy an instance of ConnectionAllocator","ref":"Membrane.RTC.Engine.Endpoint.WebRTC.ConnectionAllocator.html#c:destroy/1","title":"Membrane.RTC.Engine.Endpoint.WebRTC.ConnectionAllocator.destroy/1","type":"callback"},{"doc":"Function called by the TrackReceiver to register itself in the allocator","ref":"Membrane.RTC.Engine.Endpoint.WebRTC.ConnectionAllocator.html#c:register_track_receiver/4","title":"Membrane.RTC.Engine.Endpoint.WebRTC.ConnectionAllocator.register_track_receiver/4","type":"callback"},{"doc":"A function used by the VariantSelector to request a different bandwidth allocation. In response, the Allocator sends Membrane.RTC.Engine.Endpoint.WebRTC.ConnectionAllocator.AllocationGrantedNotification to the track receiver that gets new allocation.","ref":"Membrane.RTC.Engine.Endpoint.WebRTC.ConnectionAllocator.html#c:request_allocation/2","title":"Membrane.RTC.Engine.Endpoint.WebRTC.ConnectionAllocator.request_allocation/2","type":"callback"},{"doc":"Function used to change the negotiability status of the TrackReceiver. TrackReceiver is considered negotiable if it is both capable of decreasing its bandwidth usage and, in principal, allowed to do so.","ref":"Membrane.RTC.Engine.Endpoint.WebRTC.ConnectionAllocator.html#c:set_negotiability_status/2","title":"Membrane.RTC.Engine.Endpoint.WebRTC.ConnectionAllocator.set_negotiability_status/2","type":"callback"},{"doc":"A function called by the endpoint, to update the bandwidth estimation in the allocator","ref":"Membrane.RTC.Engine.Endpoint.WebRTC.ConnectionAllocator.html#c:update_bandwidth_estimation/2","title":"Membrane.RTC.Engine.Endpoint.WebRTC.ConnectionAllocator.update_bandwidth_estimation/2","type":"callback"},{"doc":"","ref":"Membrane.RTC.Engine.Endpoint.WebRTC.ConnectionAllocator.html#t:allocator_ref/0","title":"Membrane.RTC.Engine.Endpoint.WebRTC.ConnectionAllocator.allocator_ref/0","type":"type"},{"doc":"Type describing a message sent by ConnectionAllocator to Membrane.RTC.Engine.Endpoint.WebRTC.TrackReceiver to request that they lower their allocation.","ref":"Membrane.RTC.Engine.Endpoint.WebRTC.ConnectionAllocator.html#t:decrease_allocation_request/0","title":"Membrane.RTC.Engine.Endpoint.WebRTC.ConnectionAllocator.decrease_allocation_request/0","type":"type"},{"doc":"Type describing a message sent by Membrane.RTC.Engine.Endpoint.WebRTC.TrackReceiver to ConnectionAllocator in response to decrease_allocation_request/0 , in order to either accept or reject the request.","ref":"Membrane.RTC.Engine.Endpoint.WebRTC.ConnectionAllocator.html#t:decrease_allocation_request_response/0","title":"Membrane.RTC.Engine.Endpoint.WebRTC.ConnectionAllocator.decrease_allocation_request_response/0","type":"type"},{"doc":"Message sent by ConnectionProber to TrackReceiver whenever new allocation is granted","ref":"Membrane.RTC.Engine.Endpoint.WebRTC.ConnectionAllocator.AllocationGrantedNotification.html","title":"Membrane.RTC.Engine.Endpoint.WebRTC.ConnectionAllocator.AllocationGrantedNotification","type":"module"},{"doc":"","ref":"Membrane.RTC.Engine.Endpoint.WebRTC.ConnectionAllocator.AllocationGrantedNotification.html#t:t/0","title":"Membrane.RTC.Engine.Endpoint.WebRTC.ConnectionAllocator.AllocationGrantedNotification.t/0","type":"type"},{"doc":"Implementation of Membrane.RTC.Engine.Endpoint.WebRTC.ConnectionAllocator that grants all allocations immediately. It might be useful for non-WebRTC Endpoints","ref":"Membrane.RTC.Engine.Endpoint.WebRTC.NoOpConnectionAllocator.html","title":"Membrane.RTC.Engine.Endpoint.WebRTC.NoOpConnectionAllocator","type":"module"},{"doc":"Implementation of Membrane.RTC.Engine.Endpoint.WebRTC.ConnectionAllocator that probes the connection with RTP padding packets and grants allocations based on GCC estimates.","ref":"Membrane.RTC.Engine.Endpoint.WebRTC.RTPConnectionAllocator.html","title":"Membrane.RTC.Engine.Endpoint.WebRTC.RTPConnectionAllocator","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Membrane.RTC.Engine.Endpoint.WebRTC.RTPConnectionAllocator.html#child_spec/1","title":"Membrane.RTC.Engine.Endpoint.WebRTC.RTPConnectionAllocator.child_spec/1","type":"function"},{"doc":"","ref":"Membrane.RTC.Engine.Endpoint.WebRTC.RTPConnectionAllocator.html#t:t/0","title":"Membrane.RTC.Engine.Endpoint.WebRTC.RTPConnectionAllocator.t/0","type":"opaque"},{"doc":"Module representing simulcast configuration for WebRTC endpoint.","ref":"Membrane.RTC.Engine.Endpoint.WebRTC.SimulcastConfig.html","title":"Membrane.RTC.Engine.Endpoint.WebRTC.SimulcastConfig","type":"module"},{"doc":"Default implementation of initial_target_variant function in t/0 . Returns :high, which will result in choosing the highest possible encoding.","ref":"Membrane.RTC.Engine.Endpoint.WebRTC.SimulcastConfig.html#initial_target_variant/1","title":"Membrane.RTC.Engine.Endpoint.WebRTC.SimulcastConfig.initial_target_variant/1","type":"function"},{"doc":"Simulcast configuration. enabled - whether to accept simulcast tracks or not. Setting this to false will result in rejecting all incoming simulcast tracks i.e. client will not send them. initial_target_variant - function used to determine initial target variant this endpoint is willing to receive for given track. It is called for each track this endpoint subscribes for. If not provided, the highest possible variant will be used.","ref":"Membrane.RTC.Engine.Endpoint.WebRTC.SimulcastConfig.html#t:t/0","title":"Membrane.RTC.Engine.Endpoint.WebRTC.SimulcastConfig.t/0","type":"type"},{"doc":"Element responsible for handling WebRTC track. Its main responsibility is to request the highest available track variant. If currently used track variant becomes inactive, TrackReceiver will switch to the next available variant. Outgoing RTP packets belong to the same sequence number and timestamp spaces but they are not guaranteed to be in order and contiguous. To unpack RTP see Membrane.RTC.Engine.Track.get_depayloader/1 . To control TrackReceiver behavior see control_messages/0 . TrackReceiver also emits some notifications. They are defined in notifications/0 . Element options Passed via struct Membrane.RTC.Engine.Endpoint.WebRTC.TrackReceiver.t/0 track Track . t ( ) Required Track this adapter will maintain initial_target_variant Membrane.RTC.Engine.Track . variant ( ) Required Track variant that will be forwarded whenever it is active. Can be changed with t:set_target_variant_msg/0 . keyframe_request_interval Membrane.Time . t ( ) | nil Default value: nil Defines how often keyframe requests should be sent for currently used track variant. This option should be used in very specific cases (e.g. see HLS endpoint) as generating keyframes increases track bitrate and might introduce additional delay. connection_allocator_module module ( ) Default value: Membrane.RTC.Engine.Endpoint.WebRTC.NoOpConnectionAllocator Module implementing Membrane.RTC.Engine.Endpoint.WebRTC.ConnectionAllocator behavior that should be used by the TrackReceiver. connection_allocator pid ( ) | nil Default value: nil PID of the instance of the ConnectionAllocator that should be used by the TrackReceiver allocation_negotiable? boolean ( ) Default value: false Option defining whether allocation for this Track Receiver should be negotiable. Trying to enable negotiability for tracks that are inherently non-negotiable, also known as non-simulcast tracks, will result in a crash. This value can later be changed by sending a set_negotiable?/0 control message to this Element. telemetry_label Membrane.TelemetryMetrics . label ( ) Default value: [] Label passed to Membrane.TelemetryMetrics functions Pads :input Availability :always Caps Membrane.RTP Demand mode :manual Demand unit :buffers Direction :input Mode :push Name :input :output Availability :always Caps Membrane.RTP Demand mode :manual Demand unit :buffers Direction :output Mode :push Name :output","ref":"Membrane.RTC.Engine.Endpoint.WebRTC.TrackReceiver.html","title":"Membrane.RTC.Engine.Endpoint.WebRTC.TrackReceiver","type":"module"},{"doc":"Returns pads descriptions for Membrane.RTC.Engine.Endpoint.WebRTC.TrackReceiver","ref":"Membrane.RTC.Engine.Endpoint.WebRTC.TrackReceiver.html#membrane_pads/0","title":"Membrane.RTC.Engine.Endpoint.WebRTC.TrackReceiver.membrane_pads/0","type":"function"},{"doc":"Returns description of options available for this module","ref":"Membrane.RTC.Engine.Endpoint.WebRTC.TrackReceiver.html#options/0","title":"Membrane.RTC.Engine.Endpoint.WebRTC.TrackReceiver.options/0","type":"function"},{"doc":"Messages that can be sent to TrackReceiver to control its behavior.","ref":"Membrane.RTC.Engine.Endpoint.WebRTC.TrackReceiver.html#t:control_messages/0","title":"Membrane.RTC.Engine.Endpoint.WebRTC.TrackReceiver.control_messages/0","type":"type"},{"doc":"Notifications that TrackReceiver emits.","ref":"Membrane.RTC.Engine.Endpoint.WebRTC.TrackReceiver.html#t:notifications/0","title":"Membrane.RTC.Engine.Endpoint.WebRTC.TrackReceiver.notifications/0","type":"type"},{"doc":"Changes negotiability status of the TrackReceiver. Negotiability refers to the setting in Membrane.RTC.Engine.Endpoint.WebRTC.ConnectionAllocator that determines if the allocation for the TrackReceiver can be negotiated.","ref":"Membrane.RTC.Engine.Endpoint.WebRTC.TrackReceiver.html#t:set_negotiable?/0","title":"Membrane.RTC.Engine.Endpoint.WebRTC.TrackReceiver.set_negotiable?/0","type":"type"},{"doc":"Changes target track variant. Target track variant is variant that will be forwarded whenever it is active.","ref":"Membrane.RTC.Engine.Endpoint.WebRTC.TrackReceiver.html#t:set_target_variant/0","title":"Membrane.RTC.Engine.Endpoint.WebRTC.TrackReceiver.set_target_variant/0","type":"type"},{"doc":"Struct containing options for Membrane.RTC.Engine.Endpoint.WebRTC.TrackReceiver","ref":"Membrane.RTC.Engine.Endpoint.WebRTC.TrackReceiver.html#t:t/0","title":"Membrane.RTC.Engine.Endpoint.WebRTC.TrackReceiver.t/0","type":"type"},{"doc":"Reason of track variant switch. :low_bandwidth - bandwidth was too low to maintain current track quality :variant_inactive - variant became inactive :other - it was hard to determine the exact reason","ref":"Membrane.RTC.Engine.Endpoint.WebRTC.TrackReceiver.html#t:variant_switch_reason/0","title":"Membrane.RTC.Engine.Endpoint.WebRTC.TrackReceiver.variant_switch_reason/0","type":"type"},{"doc":"Notification emitted whenever TrackReceiver starts receiving a new track variant.","ref":"Membrane.RTC.Engine.Endpoint.WebRTC.TrackReceiver.html#t:variant_switched/0","title":"Membrane.RTC.Engine.Endpoint.WebRTC.TrackReceiver.variant_switched/0","type":"type"},{"doc":"Notfication emitted when TrackReceiver receives an update on voice activity","ref":"Membrane.RTC.Engine.Endpoint.WebRTC.TrackReceiver.html#t:voice_activity_changed/0","title":"Membrane.RTC.Engine.Endpoint.WebRTC.TrackReceiver.voice_activity_changed/0","type":"type"},{"doc":"Event for changing track variant that is currently being received. Sending this event will cause the engine to send a keyframe request event to the track origin. Once the engine receives a keyframe for the requested track variant, it will start forwarding it to the requester. If the requested track variant becomes inactive before being delivered it has to be re-requested when it becomes active again. See also Membrane.RTC.Engine.Event.TrackVariantSwitched .","ref":"Membrane.RTC.Engine.Event.RequestTrackVariant.html","title":"Membrane.RTC.Engine.Event.RequestTrackVariant","type":"module"},{"doc":"Type describing RequestTrackVariant event. variant - track variant to receive reason - reason of the request. It will be repeated in Membrane.RTC.Engine.Event.TrackVariantSwitched . Defaults to nil .","ref":"Membrane.RTC.Engine.Event.RequestTrackVariant.html#t:t/0","title":"Membrane.RTC.Engine.Event.RequestTrackVariant.t/0","type":"type"},{"doc":"Event sent whenever track variant was paused.","ref":"Membrane.RTC.Engine.Event.TrackVariantPaused.html","title":"Membrane.RTC.Engine.Event.TrackVariantPaused","type":"module"},{"doc":"Type describing TrackVariantPaused event.","ref":"Membrane.RTC.Engine.Event.TrackVariantPaused.html#t:t/0","title":"Membrane.RTC.Engine.Event.TrackVariantPaused.t/0","type":"type"},{"doc":"Event sent whenever track variant was resumed.","ref":"Membrane.RTC.Engine.Event.TrackVariantResumed.html","title":"Membrane.RTC.Engine.Event.TrackVariantResumed","type":"module"},{"doc":"Type describing TrackVariantResumed event.","ref":"Membrane.RTC.Engine.Event.TrackVariantResumed.html#t:t/0","title":"Membrane.RTC.Engine.Event.TrackVariantResumed.t/0","type":"type"},{"doc":"Event sent whenever Engine starts sending a new track variant. See also Membrane.RTC.Engine.Event.RequestTrackVariant .","ref":"Membrane.RTC.Engine.Event.TrackVariantSwitched.html","title":"Membrane.RTC.Engine.Event.TrackVariantSwitched","type":"module"},{"doc":"Type describing TrackVariantSwitched event. new_variant - variant that engine will be sending from now reason - a reason passed in Membrane.RTC.Engine.Event.RequestTrackVariant . Defaults to nil ,","ref":"Membrane.RTC.Engine.Event.TrackVariantSwitched.html#t:t/0","title":"Membrane.RTC.Engine.Event.TrackVariantSwitched.t/0","type":"type"},{"doc":"An event indicating that the voice activity on the given track has changed. Endpoints should only emit those events when they implement voice activity detection.","ref":"Membrane.RTC.Engine.Event.VoiceActivityChanged.html","title":"Membrane.RTC.Engine.Event.VoiceActivityChanged","type":"module"},{"doc":"Type describing an event indicating changes in voice activity on the given audio track.","ref":"Membrane.RTC.Engine.Event.VoiceActivityChanged.html#t:t/0","title":"Membrane.RTC.Engine.Event.VoiceActivityChanged.t/0","type":"type"},{"doc":"Message emitted when an endpoint crashes.","ref":"Membrane.RTC.Engine.Message.EndpointCrashed.html","title":"Membrane.RTC.Engine.Message.EndpointCrashed","type":"module"},{"doc":"Describes EndpointCrashed Message structure. endpoint_id - id of an endpoint that crashed","ref":"Membrane.RTC.Engine.Message.EndpointCrashed.html#t:t/0","title":"Membrane.RTC.Engine.Message.EndpointCrashed.t/0","type":"type"},{"doc":"Message emitted when an endpoint wishes to message the business logic.","ref":"Membrane.RTC.Engine.Message.EndpointMessage.html","title":"Membrane.RTC.Engine.Message.EndpointMessage","type":"module"},{"doc":"Describes EndpointMessage message structure endpoint_id - id of an endpoint message - payload of the message sent by the endpoint","ref":"Membrane.RTC.Engine.Message.EndpointMessage.html#t:t/0","title":"Membrane.RTC.Engine.Message.EndpointMessage.t/0","type":"type"},{"doc":"","ref":"Membrane.RTC.Engine.Exception.PublishTrackError.html","title":"Membrane.RTC.Engine.Exception.PublishTrackError","type":"exception"},{"doc":"","ref":"Membrane.RTC.Engine.Exception.RequestTrackVariantError.html","title":"Membrane.RTC.Engine.Exception.RequestTrackVariantError","type":"exception"},{"doc":"","ref":"Membrane.RTC.Engine.Exception.TrackReadyError.html","title":"Membrane.RTC.Engine.Exception.TrackReadyError","type":"exception"},{"doc":"","ref":"Membrane.RTC.Engine.Exception.TrackVariantStateError.html","title":"Membrane.RTC.Engine.Exception.TrackVariantStateError","type":"exception"},{"doc":"","ref":"Membrane.RTC.Engine.Exception.VoiceActivityError.html","title":"Membrane.RTC.Engine.Exception.VoiceActivityError","type":"exception"},{"doc":"Customizable Real-time Communication Engine/SFU library focused on WebRTC.","ref":"readme.html","title":"Membrane RTC Engine","type":"extras"},{"doc":"JS/TS Android iOS React Native","ref":"readme.html#client-sdks","title":"Membrane RTC Engine - Client SDKs","type":"extras"},{"doc":"The package can be installed by adding membrane_rtc_engine to your list of dependencies in mix.exs : def deps do [ { :membrane_rtc_engine , &quot;~&gt; 0.10.2&quot; } ] end","ref":"readme.html#installation","title":"Membrane RTC Engine - Installation","type":"extras"},{"doc":"For usage examples, please refer to our membrane_demo or membrane_videoroom repositories.","ref":"readme.html#usage","title":"Membrane RTC Engine - Usage","type":"extras"},{"doc":"To make the development a little easier, we have added mix integration_test task, which runs integration tests from integration/test_videoroom .","ref":"readme.html#developing","title":"Membrane RTC Engine - Developing","type":"extras"},{"doc":"Copyright 2021, Software Mansion Licensed under the Apache License, Version 2.0","ref":"readme.html#copyright-and-license","title":"Membrane RTC Engine - Copyright and License","type":"extras"},{"doc":"Apache License Version 2.0, January 2004 http://www.apache.org/licenses/ TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION 1. Definitions. &quot;License&quot; shall mean the terms and conditions for use, reproduction, and distribution as defined by Sections 1 through 9 of this document. &quot;Licensor&quot; shall mean the copyright owner or entity authorized by the copyright owner that is granting the License. &quot;Legal Entity&quot; shall mean the union of the acting entity and all other entities that control, are controlled by, or are under common control with that entity. For the purposes of this definition, &quot;control&quot; means (i) the power, direct or indirect, to cause the direction or management of such entity, whether by contract or otherwise, or (ii) ownership of fifty percent (50%) or more of the outstanding shares, or (iii) beneficial ownership of such entity. &quot;You&quot; (or &quot;Your&quot;) shall mean an individual or Legal Entity exercising permissions granted by this License. &quot;Source&quot; form shall mean the preferred form for making modifications, including but not limited to software source code, documentation source, and configuration files. &quot;Object&quot; form shall mean any form resulting from mechanical transformation or translation of a Source form, including but not limited to compiled object code, generated documentation, and conversions to other media types. &quot;Work&quot; shall mean the work of authorship, whether in Source or Object form, made available under the License, as indicated by a copyright notice that is included in or attached to the work (an example is provided in the Appendix below). &quot;Derivative Works&quot; shall mean any work, whether in Source or Object form, that is based on (or derived from) the Work and for which the editorial revisions, annotations, elaborations, or other modifications represent, as a whole, an original work of authorship. For the purposes of this License, Derivative Works shall not include works that remain separable from, or merely link (or bind by name) to the interfaces of, the Work and Derivative Works thereof. &quot;Contribution&quot; shall mean any work of authorship, including the original version of the Work and any modifications or additions to that Work or Derivative Works thereof, that is intentionally submitted to Licensor for inclusion in the Work by the copyright owner or by an individual or Legal Entity authorized to submit on behalf of the copyright owner. For the purposes of this definition, &quot;submitted&quot; means any form of electronic, verbal, or written communication sent to the Licensor or its representatives, including but not limited to communication on electronic mailing lists, source code control systems, and issue tracking systems that are managed by, or on behalf of, the Licensor for the purpose of discussing and improving the Work, but excluding communication that is conspicuously marked or otherwise designated in writing by the copyright owner as &quot;Not a Contribution.&quot; &quot;Contributor&quot; shall mean Licensor and any individual or Legal Entity on behalf of whom a Contribution has been received by Licensor and subsequently incorporated within the Work. 2. Grant of Copyright License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable copyright license to reproduce, prepare Derivative Works of, publicly display, publicly perform, sublicense, and distribute the Work and such Derivative Works in Source or Object form. 3. Grant of Patent License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable (except as stated in this section) patent license to make, have made, use, offer to sell, sell, import, and otherwise transfer the Work, where such license applies only to those patent claims licensable by such Contributor that are necessarily infringed by their Contribution(s) alone or by combination of their Contribution(s) with the Work to which such Contribution(s) was submitted. If You institute patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Work or a Contribution incorporated within the Work constitutes direct or contributory patent infringement, then any patent licenses granted to You under this License for that Work shall terminate as of the date such litigation is filed. 4. Redistribution. You may reproduce and distribute copies of the Work or Derivative Works thereof in any medium, with or without modifications, and in Source or Object form, provided that You meet the following conditions: (a) You must give any other recipients of the Work or Derivative Works a copy of this License; and (b) You must cause any modified files to carry prominent notices stating that You changed the files; and (c) You must retain, in the Source form of any Derivative Works that You distribute, all copyright, patent, trademark, and attribution notices from the Source form of the Work, excluding those notices that do not pertain to any part of the Derivative Works; and (d) If the Work includes a &quot;NOTICE&quot; text file as part of its distribution, then any Derivative Works that You distribute must include a readable copy of the attribution notices contained within such NOTICE file, excluding those notices that do not pertain to any part of the Derivative Works, in at least one of the following places: within a NOTICE text file distributed as part of the Derivative Works; within the Source form or documentation, if provided along with the Derivative Works; or, within a display generated by the Derivative Works, if and wherever such third-party notices normally appear. The contents of the NOTICE file are for informational purposes only and do not modify the License. You may add Your own attribution notices within Derivative Works that You distribute, alongside or as an addendum to the NOTICE text from the Work, provided that such additional attribution notices cannot be construed as modifying the License. You may add Your own copyright statement to Your modifications and may provide additional or different license terms and conditions for use, reproduction, or distribution of Your modifications, or for any such Derivative Works as a whole, provided Your use, reproduction, and distribution of the Work otherwise complies with the conditions stated in this License. 5. Submission of Contributions. Unless You explicitly state otherwise, any Contribution intentionally submitted for inclusion in the Work by You to the Licensor shall be under the terms and conditions of this License, without any additional terms or conditions. Notwithstanding the above, nothing herein shall supersede or modify the terms of any separate license agreement you may have executed with Licensor regarding such Contributions. 6. Trademarks. This License does not grant permission to use the trade names, trademarks, service marks, or product names of the Licensor, except as required for reasonable and customary use in describing the origin of the Work and reproducing the content of the NOTICE file. 7. Disclaimer of Warranty. Unless required by applicable law or agreed to in writing, Licensor provides the Work (and each Contributor provides its Contributions) on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied, including, without limitation, any warranties or conditions of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR PURPOSE. You are solely responsible for determining the appropriateness of using or redistributing the Work and assume any risks associated with Your exercise of permissions under this License. 8. Limitation of Liability. In no event and under no legal theory, whether in tort (including negligence), contract, or otherwise, unless required by applicable law (such as deliberate and grossly negligent acts) or agreed to in writing, shall any Contributor be liable to You for damages, including any direct, indirect, special, incidental, or consequential damages of any character arising as a result of this License or out of the use or inability to use the Work (including but not limited to damages for loss of goodwill, work stoppage, computer failure or malfunction, or any and all other commercial damages or losses), even if such Contributor has been advised of the possibility of such damages. 9. Accepting Warranty or Additional Liability. While redistributing the Work or Derivative Works thereof, You may choose to offer, and charge a fee for, acceptance of support, warranty, indemnity, or other liability obligations and/or rights consistent with this License. However, in accepting such obligations, You may act only on Your own behalf and on Your sole responsibility, not on behalf of any other Contributor, and only if You agree to indemnify, defend, and hold each Contributor harmless for any liability incurred by, or claims asserted against, such Contributor by reason of your accepting any such warranty or additional liability. END OF TERMS AND CONDITIONS APPENDIX: How to apply the Apache License to your work. To apply the Apache License to your work, attach the following boilerplate notice, with the fields enclosed by brackets &quot;[]&quot; replaced with your own identifying information. (Don't include the brackets!) The text should be enclosed in the appropriate comment syntax for the file format. We also recommend that a file or class name and description of purpose be included on the same &quot;printed page&quot; as the copyright notice for easier identification within third-party archives. Copyright 2021 Software Mansion Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"license.html","title":"LICENSE","type":"extras"},{"doc":"This document described all messages exchanged between the WebRTC Endpoint and a client. In general, each media event has to be sent in the form: { type: name, data: data } where the name of the event is the value of the type field, while data should carry the data shown below for every media event","ref":"webrtc_media_events.html","title":"WebRTC Media Events","type":"extras"},{"doc":"Below you can find a summary of all media events defined inside membrane_rtc_engine Generic WebRTC Endpoint messages Messages used by any WebRTC Endpoint plugin WebRTC Endpoint receives these types of media_events from client: Name Description join sent when peer join WebRTC Endpoint leave sent when peer leaves WebRTC Endpoint updatePeerMetadata contains new metadata of a peer updateTrackMetadata contains new metadata of a track custom message forwarded to the endpoint associated with the peer WebRTC Endpoint sends these types of messages to the client: Name Description tracksPriority contains all tracks that will be forwarded to peer until next tracks_priority message peerDenied sent if peer was rejected by server when joining to server peerUpdated contains new metadata of a peer trackUpdated contains new metadata of a track tracksAdded sent when some tracks were added by some peer tracksRemoved sent when some tracks were removed by some peer peerJoined sent after a new peer has joined the WebRTC Endpoint peerAccepted sent to a peer after he joins the WebRTC Endpoint peerLeft sent when some peer lefts the WebRTC Endpoint peerRemoved sent when peer is forcibly removed by the server error Notifies about an error that occurred custom custom message forwarded from endpoint to client WebRTC custom media events WebRTC endpoint receives these types of custom media_event s from client: Name Description renegotiateTracks A request from a peer to renegotiate tracks prioritizeTrack A request to prioritize the track unprioritizeTrack A request to unprioritize the track preferedVideoSizes informs of how many videos in different quality a peer wants to receive candidate Contains client's ICE candidate sdpOffer Contains an SDP offer from a client setTargetTrackVariant A request from a peer to receive a specific track variant WebRTC endpoint sends these type of custom messages to client Name Description offerData Sends data needed by the client to create an offer candidate Contains an ICE candidate sdpAnswer Provides an SDP Answer to the client's offer encodingSwitched An information that a track will be sent with a specific encoding vadNotification An update on Voice Activity Detection","ref":"webrtc_media_events.html#table-of-contents","title":"WebRTC Media Events - Table of contents","type":"extras"},{"doc":"join Sent when peer want to join WebRTC Endpoint. It contains only peer's metadata { &quot;metadata&quot;: any } leave Sent when peer leaves WebRTC Endpoint. It contains no data {} updatePeerMetadata Contains new metadata of some peer { &quot;metadata&quot;: any } updateTrackMetadata Contains new metadata of some track and an id of this track { &quot;trackId&quot;: track_id, &quot;trackMetadata&quot;: any } custom A black-box for a message that WebRTC Endpoint will forward to the endpoint associated with the peer who sent the message. any","ref":"webrtc_media_events.html#client-webrtc-endpoint","title":"WebRTC Media Events - Client -&gt; WebRTC Endpoint","type":"extras"},{"doc":"tracksPriority Contains all tracks that will be forwarded to peer until the next tracks_priority message. This type of messages is sent only if DisplayManager is spawned { tracks: tracks } peerDenied Sent if peer was rejected by server when joining to server. It may contain a reason for rejection. { data: text } peerUpdated Contains information about updated metadata of one of the peers { peerId: peer_id, metadata: any } trackUpdated Contains information about new metadata of one of tracks { peerId: peer_id, trackId: track_id, metadata: any } tracksAdded Informs that one of the peers has added one or more tracks. It contains an id of that peer and a map of all tracks with track_id s as keys and track_metadata as value. { peerId: peer_id, trackIdToMetadata: { track_id: any } } tracksRemoved Contains a list of tracks which have been removed by some peer and id of that peer { peerId: peer_id, trackIds: track_ids } peerJoined Message sent to all peers in the room after a new peer has joined WebRTC Endpoint. It contains id and metadata of the new peer. { peer: { id: peer.id, metadata: peer.metadata } } peerAccepted Message sent to the peer after he's joined the WebRTC Endpoint. It contains his id and a list of information about peers in the Engine (id, metadata and a trackIdToMetadata like seen in tracksAdded ) { id: peer_id, peersInRoom: peers } peerLeft Sent to all remaining peers in the room after some peer has left. It contains an id of the peer who left. { peerId: peer_id } peerRemoved Sent to the peer that has been forcibly removed by the server { peerId: peer_id, reason: any } error Informs that an error occurred on the server providing a message to show { message: any() } custom WARNING!! This type of media event is deprecated - will soon be removed. A black-box for a message that the WebRTC Endpoint will forward to the client. any","ref":"webrtc_media_events.html#webrtc-endpoint-client","title":"WebRTC Media Events - WebRTC Endpoint -&gt; Client","type":"extras"},{"doc":"renegotiateTracks Informs that a peer wants to renegotiate connection due to adding a track or removing a track {} prioritizeTrack Contains an id of the track that the peer wants to prioritize { trackId: trackId } unprioritizeTrack Contains an id of the track that the peer want to unprioritize. { trackId: trackId } preferedVideoSizes Contains information of how many videos in different quality (high, medium, small) the peer would like to receive. allSameSize flag which indicates that all videos should be in the same quality. { bigScreens: Int, mediumScreens: Int, smallScreens: Int, allSameSize: boolean } candidate Contains an ICE candidate that is forwarded to the WebRTC Endpoint { candidate: candidate, sdpMLineIndex: Int } sdpOffer Contains an SDP offer, a mapping between track_id and track_metadata , and a mapping between mid and track_id . Both maps contain only information about current peer sendonly tracks. { sdpOffer: { type: &quot;offer&quot;, sdp: sdp_offer }, trackIdToTrackMetadata: { trackId: any } midToTrackId: mid_to_track_id } setTargetTrackVariant Informs that a peer wants to receive a specific track variant. The track variant will be sent whenever it is available. If choosen variant is unavailable, some other variant will be sent until choosen variant becomes active again. { trackId =&gt; track_id, variant =&gt; variant }","ref":"webrtc_media_events.html#client-webrtc-enpoint","title":"WebRTC Media Events - Client -&gt; WebRTC Enpoint","type":"extras"},{"doc":"offerData Contains information about the number of audio and video tracks that will be sent from the engine to the peer and information regarding the integrated TURN server. { tracksTypes: { audio: Int, video: Int }, integratedTurnServers: [{ serverAddr: addr, serverPort: Int, transport: string, password: string, username: string }] } candidate Contains information about an ICE candidate which will be sent to the client { candidate: candidate, sdpMLineIndex: sdp_m_line_index, sdpMid: nil, usernameFragment: nil } sdpAnswer Contains an SDP answer and mapping between mid and track_id for all tracks (active, inactive, inbound and outbound) { type: &quot;answer&quot;, sdp: sdp_answer, midToTrackId: mid_to_track_id } encodingSwitched Informs that track with id trackId belonging to peer with id peerId will be sent in encoding encoding now. The meaning is as follows: &quot;low_bandwidth&quot; - we no longer have enough bandwidth to maintain current track quality &quot;encoding_inactive&quot; - encoding became inactive &quot;other&quot; - it was hard to determine exact reason of encoding switch { peerId: peer_id, trackId: track_id, encoding: encoding, reason: &quot;low_bandwidth&quot; | &quot;encoding_inactive&quot; | &quot;other&quot; } vadNotification Informs that the track denoted by trackId has changed their voice actiivty For this notification to work, the server must be configured to use VAD extension and the sender must support it. { trackId: track_id, status: &quot;silence&quot; | &quot;speech&quot; } bandwidthEstimation Informs about client's available incoming bitrate (a.k.a. download) estimated by the server. It is measured in bits per second. For this notification to work, the server must be configured to use TWCC extension and the sender must support it. { estimation: estimation, }","ref":"webrtc_media_events.html#webrtc-enpoint-client","title":"WebRTC Media Events - WebRTC Enpoint -&gt; Client","type":"extras"},{"doc":"Joining the server sequenceDiagram actor client participant server actor other_client client-&gt;&gt;server: join server-&gt;&gt;client: peerAccepted server-&gt;&gt;other_client: peerJoined Adding a track sequenceDiagram actor client participant server actor other_client client-&gt;&gt;server: renegotiateTracks server-&gt;&gt;client: custom(offerData) client-&gt;&gt;server: custom(sdpOffer) par client-&gt;&gt;server: custom(candidate) and server-&gt;&gt;client: custom(sdpAnswer) server-&gt;&gt;client: custom(candidate) server-&gt;&gt;other_client: tracksAdded server-&gt;&gt;client: tracksAdded rect rgb(135, 204, 232) note right of server: renegotiation server-&gt;&gt;other_client: custom(offerData) other_client-&gt;&gt;server: custom(sdpOffer) par other_client-&gt;&gt;server: custom(candidate) and server-&gt;&gt;other_client: custom(sdpAnswer) server-&gt;&gt;other_client: custom(candidate) end end end Leaving the server sequenceDiagram actor client participant server actor other_client client-&gt;&gt;server: leave server-&gt;&gt;other_client: peerLeft rect rgb(135, 204, 232) note right of server: renegotiation server-&gt;&gt;other_client: custom(offerData) other_client-&gt;&gt;server: custom(sdpOffer) par other_client-&gt;&gt;server: custom(candidate) and server-&gt;&gt;other_client: custom(sdpAnswer) server-&gt;&gt;other_client: custom(candidate) end end","ref":"protocol.html","title":"Signaling Protocol","type":"extras"},{"doc":"The WebRTC Endpoint is responsible for sending/receiving media tracks to/from a web borwser.","ref":"webrtc_endpoint.html","title":"WebRTC Endpoint","type":"extras"},{"doc":"","ref":"webrtc_endpoint.html#architecture","title":"WebRTC Endpoint - Architecture","type":"extras"},{"doc":"TrackSender is responsible for observing track activity and publishing track data to the engine. In particular, it is responsible for sending Membrane.RTC.Engine.Event.TrackVariantResumed and Membrane.RTC.Engine.Event.TrackVariantPaused events, and replying to Membrane.KeyframeRequestEvent . VariantTracker A browser can pause sending some encoding when e.g. it doesn't have enough bandwidth. This fact is not communicated to the server. VariantTracker is responsible for tracking variant activity i.e. whether it is still active.","ref":"webrtc_endpoint.html#tracksender","title":"WebRTC Endpoint - TrackSender","type":"extras"},{"doc":"TrackReceiver is responsible for receiving a track from the engine. In particular, it is responsible for sending the Membrane.RTC.Engine.Event.RequestTrackVariant event, forwarding keyframe requests from the browser to the TrackSender and repairing RTP packets after switching track variants.","ref":"webrtc_endpoint.html#trackreceiver","title":"WebRTC Endpoint - TrackReceiver","type":"extras"},{"doc":"ConnectionAllocator is responsible for probing the connection and negotiating bandwidth with TrackReceiver . The RTC Engine ships with two implementations of ConnectionAllocator : Membrane.RTC.Engine.Endpoint.WebRTC.NoOpConnectionAllocator - always grants bandwidth requested by TrackReceiver Membrane.RTC.Engine.Endpoint.WebRTC.RTPConnectionAllocator - probes the connection with RTP padding packets and grants bandwidth basing on GCC estimates You can read more in Membrane.RTC.Engine.Endpoint.WebRTC.ConnectionAllocator module docs.","ref":"webrtc_endpoint.html#connectionallocator","title":"WebRTC Endpoint - ConnectionAllocator","type":"extras"},{"doc":"Simulcast is a technique where a client sends multiple encodings of the same video to the server and the server is responsbile for choosing and forwarding proper encoding to proper receiver (other client). The encoding selection is dynamic (i.e. SFU switches between encodings in time) and it is based on: receiver awailable bandwidth receiver preferences (e.g. explicit request to receive video in HD resolution instead of FHD) UI layaout (e.g. videos being displayed in smaller video tiles will be sent in lower resolution) At the moment, Membrane supports only receiver preferences i.e. receiver can chose which encoding it is willing to receive. Additionaly, sender can turn off/on specific encoding. Membrane RTC Engine will detect changes and switch to another available encoding.","ref":"internal_simulcast.html","title":"Simulcast","type":"extras"},{"doc":"At the moment, both H264 and VP8 codecs are supported.","ref":"internal_simulcast.html#codecs","title":"Simulcast - Codecs","type":"extras"},{"doc":"Switching between encodings has to be performed transparently from the receiver point of view. This implies that: server has to rewrite some fields of RTP packets to avoid gaps in sequence numbers or timestamps after encoding switch i.e. receiver has to think it is still receiving the same RTP stream encoding switch has to be performed when server receives a keyframe from the new encoding. In other case video will freeze for a while after switching encodings.","ref":"internal_simulcast.html#logic","title":"Simulcast - Logic","type":"extras"},{"doc":"It is responsible for forwarding proper encoding. It encapsulates mungers (described below).","ref":"internal_simulcast.html#forwarder","title":"Simulcast - Forwarder","type":"extras"},{"doc":"Mungers are responsible for modyfing RTP packets so that switching between encodings is transparent for the receiver. Currently, there are two mungers: RTP Munger and VP8 Munger. H264 doesn't require modyfing its RTP packets so there is no H264 Munger. RTP Munger Rewrites RTP Header fields - sequence numbers and timestamps. SSRC is being rewritten by other Membrane element. VP8 Munger Rewrites VP8 RTP payload fields - keyidx, picture_id, tl0picidx","ref":"internal_simulcast.html#mungers","title":"Simulcast - Mungers","type":"extras"},{"doc":"Simulcast can be disabled per WebRTC Endpoint. At the moment, if client offers simulcast but we don't accept it, we will disable the whole track. This is not compliant with WebRTC standard as we should only remove SDP attributes related to simulcast and be prepared for receiving one encoding. However, in such a case browser changes SSRC after ICE restart and we cannot handle this at the moment.","ref":"internal_simulcast.html#disabling-simulcast","title":"Simulcast - Disabling Simulcast","type":"extras"},{"doc":"The RTC Engine is responsible for forwarding tracks to proper endpoints. We require tracks to be published in the form of RTP packets however, neither engine nor tee has fields that are RTP or WebRTC specific. Protocol-specific logic should be handled inside specific endpoints. The assumption that the engine is protocol-agnostic greatly simplifies its architecture and code while the assumption that a track has to be published in the form of RTP packets allows us to put some WebRTC-specific fields inside the track's struct. For each track, there is a separate tee responsible for forwarding this track to all subscribed endpoints.","ref":"internal_engine_architecture.html","title":"Engine Architecture","type":"extras"},{"doc":"There are two types of tracks - audio and video. Video tracks might be in multiple qualities/resolutions. We call them variants and indentify them using atoms - :high , :medium , :low . In general: :high - main track resolution :medium - main track resolution scaled down by 2 :low - main track resolution scaled down by 4 Audio tracks can have only one variant - :high . At first, each track is created with Membrane.RTC.Engine.Track.new/7 . It is important that the engine supports only RTP tracks so each endpoint that publishes some track has to publish it in the form of RTP packets. Unpacking RTP stream If you are writing an endpoint that consumes data from the engine you can get media out of RTP packets with the support of Membrane.RTC.Engine.Track.get_depayloader/1 . After creating a track it is published using Membrane.RTC.Engine.publish_action_t/0 . This causes the engine to notify other endpoints about new tracks and allows other endpoints to subscribe to them. Next, each track variant is marked as ready with Membrane.RTC.Engine.track_ready_action_t/0 . The action informs the engine that it can link bin's output pad to the engine itself. At this point, the track is published and marked as ready. Next section outlines how resuming, pausing and requesting track variants looks like.","ref":"track_lifecycle.html","title":"Track Lifecycle","type":"extras"},{"doc":"Resuming and pausing track variant Endpoint ---- TrackVariantResumed (:medium) ---&gt; Engine Endpoint ---- media (:medium) ---&gt; Engine Endpoint ---- TrackVariantResumed (:low) ---&gt; Engine Endpoint ---- media (:low) ---&gt; Engine Endpoint ---- TrackVariantPaused (:medium) ---&gt; Engine General rules: media can flow only when a track variant is in the resumed state when a track variant becomes inactive for some reason (e.g. browser stops sending it to the server because of bandwidth limitation), such variant is marked as paused with Membrane.RTC.Engine.Event.TrackVariantPaused . Requesting track variant Engine ---- TrackVariantResumed (:medium) ---&gt; Endpoint Engine &lt;--- RequestTrackVariant (:medium) ---- Endpoint Engine ---- TrackVariantResumed (:low) ---&gt; Endpoint Engine ---- TrackVariantSwitched ---&gt; Endpoint Engine ---- media ---&gt; Endpoint Engine ---- TrackVariantPaused (:medium) ---&gt; Endpoint Engine &lt;--- RequestTrackVariant (:low) ---- Endpoint General rules: after requesting a track variant but before receiving the very first media packets, there is always the Membrane.RTC.Engine.Event.TrackVariantSwitched event. if requested track variant becomes inactive before being delivered, it has to be re-requested once it becomes active again sending the Membrane.RTC.Engine.Event.RequestTrackVariant event causes engine to send the Membrane.KeyframeRequestEvent event to the track origin. Once engine receives a keyframe from the publisher it will start forwarding requested track.","ref":"track_lifecycle.html#managing-track-variants","title":"Track Lifecycle - Managing track variants","type":"extras"},{"doc":"This section outlines how to implement a custom RTC Engine endpoint that saves tracks published by the WebRTC endpoint. Before you continue It is recommended to read Track Lifcycle section before diving deeper in this guide. You will also find there some information about publishing a track. HLS endpoint Another endpoint that saves WebRTC tracks and is shipped with the engine is the HLS endpoint .","ref":"custom_endpoints.html","title":"Custom endpoint","type":"extras"},{"doc":"Each RTC Engine endpoint has to: implement Membrane.Bin behavior have at least one Membrane element that will be responsible for producing or consuming data as Membrane bins are used only for logical grouping - they don't process data publish or/and subscribe to tracks","ref":"custom_endpoints.html#general-rules","title":"Custom endpoint - General rules","type":"extras"},{"doc":"To implement Membrane.Bin behavior we have to: use Membrane.Bin specify some configuration options (if needed) specify input and/or output pads implement some callbacks. Pads definition depends on what our bin is intended to do. For example, if our endpoint does not publish any tracks but only subscribes for tracks from other endpoints it can specify only input pads. Pads should be in the following form def_input_pad :input , demand_unit : :buffers , caps : Membrane.RTP , availability : :on_request def_output_pad :output , demand_unit : :buffers , caps : Membrane.RTP , availability : :on_request When it comes to endpoint options we will have: rtc_engine - pid of RTC engine. It will be used for subscribing for a track output_dir_path - output directory path i.e. where our tracks should be saved. Putting it all together we have defmodule RecordingEndpoint do @moduledoc &quot;&quot;&quot; Endpoint for saving tracks to a disk. Each track will be saved in a separate file. &quot;&quot;&quot; use Membrane.Bin alias Membrane.RTC.Engine def_options rtc_engine : [ spec : pid ( ) , description : &quot;Pid of parent Engine&quot; ] , output_dir_path : [ spec : Path . t ( ) , description : &quot;Path to directory, where tracks will be saved.&quot; ] def_input_pad :input , demand_unit : :buffers , caps : :any , availability : :on_request @impl true def handle_init ( opts ) do state = %{ directory_path : opts . directory_path , rtc_engine : opts . rtc_engine } { :ok , state } end end","ref":"custom_endpoints.html#implementing-membrane-bin","title":"Custom endpoint - Implementing Membrane.Bin","type":"extras"},{"doc":"Because Membrane.Bin s are not capable of sending or consuming any data on their own (they can be more thought of as logical containers) we have to add at least one casual Membrane element that will do this for us. In our case, we will need three elements: Membrane.RTC.Engine.Endpoint.WebRTC.TrackReceiver - responsible for requesting the highest possible track variant and switching to other variants when the currently used one becomes inactive Membrane.Stream.Serializer - used for serializing incoming Membrane stream Membrane.File.Sink - used for saving serialized data into a file For each incoming track we will create separate serializer and sink.","ref":"custom_endpoints.html#consuming-data","title":"Custom endpoint - Consuming data","type":"extras"},{"doc":"Whenever some endpoint publishes its tracks, all other endpoints receive a message in form of {:new_tracks, tracks} where tracks is a list of Membrane.RTC.Engine.Track.t/0 . To subscribe to any of the published tracks, an endpoint has to call Membrane.RTC.Engine.subscribe/4 . After subscribing for a track the endpoint will be notified about its readiness in Membrane.Bin.handle_pad_added/3 callback. An example implementation of handle_pad_added callback can look like this @impl true def handle_pad_added ( Pad . ref ( :input , track_id ) = pad , _ctx , state ) do children = %{ { :track_receiver , track_id } =&gt; % TrackReceiver { track : Map . fetch! ( state . tracks , track_id ) , initial_target_variant : :high } , { :serializer , track_id } =&gt; Membrane.Stream.Serializer , { :sink , track_id } =&gt; % Membrane.File.Sink { location : Path . join ( state . output_dir_path , track_id ) } } links = [ link_bin_input ( pad ) |&gt; to ( { :track_receiver , track_id } ) |&gt; to ( { :serializer , track_id } ) |&gt; to ( { :sink , track_id } ) ] { { :ok , spec : % ParentSpec { children : children , links : links } } , state } end We simply link our input pad on which we will receive media data to the track receiver, serializer and then to the sink. The endpoint will be also notified when some tracks it subscribed for are removed with {:removed_tracks, tracks} message. Deeper dive into TrackReciver After linking the input pad for a given track, our endpoint will start receiving events. The very first event is always TrackVariantResumed . It informs that a given track variant is available and can be requested with the RequestTrackVariant event. The engine ensures that each endpoint always receives a track variant starting from a keyframe, so before receiving the first media packets our endpoint will receive the TrackVariantSwitched event and finally media packets will start flowing. When some track variant is paused, the endpoint will receive the TrackVariantPaused event. The whole process is shown in the following diagram Engine ---- TrackVariantResumed (:medium) ---&gt; Endpoint Engine &lt;--- RequestTrackVariant (:medium) ---- Endpoint Engine ---- TrackVariantResumed (:low) ---&gt; Endpoint Engine ---- TrackVariantSwitched ---&gt; Endpoint Engine ---- media ---&gt; Endpoint Engine ---- TrackVariantPaused (:medium) ---&gt; Endpoint Engine &lt;--- RequestTrackVariant (:low) ---- Endpoint Because this logic must be duplicated in each endpoint we encapsulated it into TrackReceiver that can easily be plugged in before the actual Membrane element. Putting it all together defmodule RecordingEndpoint do @moduledoc &quot;&quot;&quot; Endpoint for saving tracks to a disk. Each track will be saved in a separate file. &quot;&quot;&quot; use Membrane.Bin require Membrane.Logger alias Membrane.RTC.Engine alias Membrane.RTC.Engine.Endpoint.WebRTC.TrackReceiver def_options rtc_engine : [ spec : pid ( ) , description : &quot;Pid of parent Engine&quot; ] , output_dir_path : [ spec : Path . t ( ) , description : &quot;Path to directory, where tracks will be saved.&quot; ] def_input_pad :input , demand_unit : :buffers , caps : :any , availability : :on_request @impl true def handle_init ( opts ) do state = %{ output_dir_path : opts . output_dir_path , rtc_engine : opts . rtc_engine , tracks : %{ } } { :ok , state } end @impl true def handle_pad_added ( Pad . ref ( :input , track_id ) = pad , _ctx , state ) do children = %{ { :track_receiver , track_id } =&gt; % TrackReceiver { track : Map . fetch! ( state . tracks , track_id ) , initial_target_variant : :high } , { :serializer , track_id } =&gt; Membrane.Stream.Serializer , { :sink , track_id } =&gt; % Membrane.File.Sink { location : Path . join ( state . output_dir_path , track_id ) } } links = [ link_bin_input ( pad ) |&gt; to ( { :track_receiver , track_id } ) |&gt; to ( { :serializer , track_id } ) |&gt; to ( { :sink , track_id } ) ] { { :ok , spec : % ParentSpec { children : children , links : links } } , state } end @impl true def handle_pad_removed ( Pad . ref ( :output , track_id ) , _ctx , state ) do children = [ { :track_receiver , track_id } , { :serialized , track_id } , { :sink , track_id } ] { { :ok , remove_child : children } , state } end @impl true def handle_other ( { :new_tracks , tracks } , ctx , state ) do { :endpoint , endpoint_id } = ctx . name Enum . reduce_while ( tracks , { :ok , state } , fn track , { :ok , state } -&gt; case Engine . subscribe ( state . rtc_engine , endpoint_id , track . id ) do :ok -&gt; { :cont , { :ok , update_in ( state , [ :tracks ] , &amp; Map . put ( &amp;1 , track . id , track ) ) } } { :error , :invalid_track_id } -&gt; Membrane.Logger . warn ( &quot;&quot;&quot; Couldn&#39;t subscribe to the track: \#{ inspect ( track . id ) } . No such track. It had to be removed just after publishing it. Ignoring. &quot;&quot;&quot; ) { :cont , { :ok , state } } { :error , reason } -&gt; raise &quot;Couldn&#39;t subscribe to the track: \#{ inspect ( track . id ) } . Reason: \#{ inspect ( reason ) } &quot; end end ) end @impl true def handle_other ( { :remove_tracks , [ ] } , _ctx , state ) do { :ok , state } end end","ref":"custom_endpoints.html#subscribing-for-a-track","title":"Custom endpoint - Subscribing for a track","type":"extras"},{"doc":"Simulcast is a technique where a client sends multiple encodings of the same video to the server and the server is responsible for choosing and forwarding proper encoding to proper receiver (other client). The encoding selection is dynamic (i.e. SFU switches between encodings in time) and it is based on: receiver available bandwidth receiver preferences (e.g. explicit request to receive video in HD resolution instead of FHD) UI layout (e.g. videos being displayed in smaller video tiles will be sent in a lower resolution) At the moment, Membrane supports only receiver preferences i.e. receiver can chose which encoding it is willing to receive. Additionally, sender can turn off/on specific encoding. Membrane RTC Engine will detect changes and switch to another available encoding.","ref":"simulcast.html","title":"Simulcast","type":"extras"},{"doc":"Server side On the server side, simulcast can be configured while adding new WebRTC Endpoint by setting its simulcast_config option. Remember to ensure Rid , Mid and TWCC extensions are used. For example alias Membrane.RTC.Engine.Endpoint.WebRTC alias Membrane.RTC.Engine.Endpoint.WebRTC.SimulcastConfig alias Membrane.WebRTC.Extension . { Mid , Rid , TWCC } # ... % WebRTC { rtc_engine : rtc_engine , # ... webrtc_extensions : [ Rid , Mid , TWCC ] , simulcast_config : % SimulcastConfig { enabled : true , initial_target_variant : fn _track_ -&gt; :medium end } } Here we turn simulcast on and choose :medium variant as a target for each track that is going to be forwarded to the browser. Target variant means that it will be chosen whenever it is active. If for some reason :medium variant is inactive we will temporarily forward some other variant. On the other hand, setting enabled to false will result in rejecting all incoming simulcast tracks i.e. client will not send them to the server. Client side On the client side simulcast can be enabled while adding a new track and might differ depending on the client type e.g. for JS see https://docs.membrane.stream/membrane-webrtc-js/classes/membranewebrtc.html#addtrack","ref":"simulcast.html#turning-simulcast-on-off","title":"Simulcast - Turning simulcast on/off","type":"extras"},{"doc":"RTC Engine and its endpoints add following metadata to logs: rtc_engine - RTC Engine id passed to Membrane.RTC.Engine.start_link/2 or Membrane.RTC.Engine.start/2 webrtc_endpoint - WebRTC endpoint id passed as peer_id to Membrane.RTC.Engine.add_endpoint/3 Metadata has to be turned on in config files with config :logger , :console , metadata : [ :rtc_engine , :webrtc_endpoint ] Additionaly, some endpoints might accept their own log metadata e.g. endpoint = % WebRTC { log_metadata : [ some_additional_metadata : &quot;some_additional_metadata&quot; ] , }","ref":"logs.html","title":"Logs","type":"extras"},{"doc":"RTC Engine uses membrane_telemetry_metrics to aggregate data about media streams and generate reports about them. To enable metrics aggregation, you have to put line config :membrane_telemetry_metrics , enabled : true in your config file and start Membrane.TelemetryMetrics.Reporter with RTC Engine metrics by calling { :ok , reporter } = Membrane.TelemetryMetrics.Reporter . start_link ( Membrane.RTC.Engine.Metrics . metrics ( ) ) Then, if you want to get a report with metrics values for every running RTC Engine on the node, you have to call Membrane.TelemetryMetrics.Reporter . scrape ( reporter ) There is a report example below, with only one room with one peer inside %{ { :room_id , &quot;my_meeting&quot; } =&gt; %{ { :peer_id , &quot;aa83837e-c18a-4d0e-b7f1-565acdddd3e0&quot; } =&gt; %{ { :track_id , &quot;aa83837e-c18a-4d0e-b7f1-565acdddd3e0:2cfee338-37f9-46cf-8c5b-d3909caa4dce:l&quot; } =&gt; %{ &quot;inbound-rtp.frames&quot; =&gt; 5450 , &quot;inbound-rtp.keyframes&quot; =&gt; 46 , &quot;inbound-rtp.bytes_received&quot; =&gt; 4106974 , &quot;inbound-rtp.encoding&quot; =&gt; :VP8 , &quot;inbound-rtp.keyframe_request_sent&quot; =&gt; 22 , &quot;inbound-rtp.packets&quot; =&gt; 6099 , &quot;inbound-rtp.ssrc&quot; =&gt; 1507540019 } , { :track_id , &quot;aa83837e-c18a-4d0e-b7f1-565acdddd3e0:2cfee338-37f9-46cf-8c5b-d3909caa4dce:m&quot; } =&gt; %{ &quot;inbound-rtp.frames&quot; =&gt; 5303 , &quot;inbound-rtp.keyframes&quot; =&gt; 45 , &quot;inbound-rtp.bytes_received&quot; =&gt; 21999552 , &quot;inbound-rtp.encoding&quot; =&gt; :VP8 , &quot;inbound-rtp.keyframe_request_sent&quot; =&gt; 22 , &quot;inbound-rtp.packets&quot; =&gt; 20757 , &quot;inbound-rtp.ssrc&quot; =&gt; 1441607303 } , { :track_id , &quot;aa83837e-c18a-4d0e-b7f1-565acdddd3e0:a8ffd71d-932a-4955-b4da-d941449aa329:&quot; } =&gt; %{ &quot;inbound-rtp.frames&quot; =&gt; 11348 , &quot;inbound-rtp.bytes_received&quot; =&gt; 1175977 , &quot;inbound-rtp.encoding&quot; =&gt; :OPUS , &quot;inbound-rtp.keyframe_request_sent&quot; =&gt; 22 , &quot;inbound-rtp.packets&quot; =&gt; 11348 , &quot;inbound-rtp.ssrc&quot; =&gt; 3192426135 } , &quot;ice.binding_requests_received&quot; =&gt; 94 , &quot;ice.binding_responses_sent&quot; =&gt; 94 , &quot;ice.bytes_received&quot; =&gt; 27329251 , &quot;ice.bytes_sent&quot; =&gt; 76030 , &quot;ice.packets_received&quot; =&gt; 39189 , &quot;ice.packets_sent&quot; =&gt; 975 } } } You can also go to membrane_videoroom or membrane_telemetry_metrics docs for more examples.","ref":"metrics.html","title":"Metrics","type":"extras"},{"doc":"RTC Engine uses membrane_opentelemetry to generate OpenTelemetry traces and spans. You can enable traces in your config.exs : config :membrane_opentelemetry , enabled : true Besides this you need to put :opentelemetry config in config/runtime.exs , for example config :opentelemetry , :resource , service : [ name : &quot;membrane_rtc_engine&quot; , namespace : &quot;membrane&quot; ] , processors : [ otel_batch_processor : %{ exporter : { :otel_exporter_stdout , [ ] } } ] Where: service - name and namespace of the service. They are used for easier distinction from other services. You can read more here processors - defines when spans should be exported. otel_simple_procesor flushes each span immediately after ending it while otel_batch_processor buffers several spans and flushes them in a batch. For more see otel_simple_processor or otel_batch_processor exporter - defines where spans should be exported. otel_exporter_stdout prints spans to stdout but there are other exporters that can visualize traces in a human readable format like Zipkin To see more about :opentelemetry config, you can go to the OpenTelemetry documentation You can also go to membrane_videoroom for more examples.","ref":"traces.html","title":"Traces","type":"extras"},{"doc":"Voice Activity Detection (VAD) is a feature available in Membrane RTC Engine that allows you to receive notifications about voice activity. You may also know it as speech detection. After enabling this feature, you're going to start receiving vadNotification media events in your client application. These media events contain a trackId and vadStatus - either speech or silence. Depending on the SDK, a callback or other means of publishing this information may be available. Please refer to the documentation of your SDK.","ref":"vad.html","title":"Voice Activity Detection","type":"extras"},{"doc":"To enable VAD you need to Enable VAD RTP header extension Enable VAD WebRTC extension In practice, ensure that: Membrane.Webrtc.Extension.VAD is present in the webrtc_extensions key of your WebRTC Endpoint configuration The following is part of the extensions key in your WebRTC Endpoint configuration %{ opus : Membrane.RTP.VAD }","ref":"vad.html#enabling-vad","title":"Voice Activity Detection - Enabling VAD","type":"extras"}]